<template>
  <div>
    <PageCard
      class="signIn_wrapper"
      :title="$t('authorization.step2.part2.title')"
      :bordering="false"
      dark>
      <div class="signIn_inner">
        <div class="signIn_inner-description">
          {{$t('authorization.step2.part2.description')}}
        </div>
      </div>
    </PageCard>
    <PageCard :bordering="false">
      <div class="signIn_inner-body">
        <div class="mnemonics_qr">
          <div
            class="mnemonics_qr-img"
            id="qrcode"></div>
          <BtnDark
            @click="gaqr"
            id="forceLink"
            data-href=""
            color="#8591a9"
            :backgroundColor="copied ? '#00bdc5' : '#192233'"
            borderColor="#00bdc5"
            ref="link">{{$t('authorization.step2.part2.btn')}} <!--@click="createPdf"-->
            <template slot="img">
              <IconCopy
                class="mt-3p ml-10"
                fill="#8591a9"></IconCopy>
            </template>
          </BtnDark>
          <div id="test" style="color: white;">

          </div>
        </div>
      </div>
    </PageCard>
  </div>
</template>

<script>
  import BtnDark from '~/components/UI/BtnSign_dark';
  import IconCopy from '~/components/UI/icons/icon-copy';
  import PageCard from '~/components/UI/PageCard';

  import {Wallet} from '~/services/wallet/';
  import QRCode from 'qrcode-generator';
  import * as jsPDF from 'jspdf/dist/jspdf.debug';
  import MobileDetect from 'mobile-detect';

  export default {
    name: "Step2_ThePart2",
    data() {
      return {
        mnemonicsFirst: [],
        mnemonicsSecond: [],
        qrcode: null,
        pdf: null,
        privateKey: '',
        qrcodeUri: '',
        copied: false
      }
    },
    components: {
      BtnDark,
      IconCopy,
      PageCard
    },
    computed: {
      mnemonic() {
        return this.$store.state.signIn.mnemonic;
      }
    },
    methods: {
      gaqr() {
        this.ga('copyq');
      },
      change(val, field) {
        this[field] = val;
      },
      nextStep() {
        this.$store.commit('signIn/SET_STEP', {
          key: 'step2',
          value: true
        });
        this.$emit('nextStep');
      },

      copy(text) {
        copyClipboard(text, this.$t('common.copy'));
      },
      createPdf() {
        return new Promise((resolve, reject) => {
          const dataurl = this.qrcode.createDataURL();
          this.pdf = new jsPDF();
          this.pdf.setProperties({
            title: 'Passport',
            author: '16Bit'
          });
          this.pdf.addImage(dataurl, 'GIF', 15, 0, 140, 140);
          this.pdf.setFontSize(20);
          this.pdf.text(15, 165, 'Private key: ');
          this.pdf.setFontSize(13);
          const keys = this.privateKey.split(':');
          this.pdf.text(15, 175, `${keys[0]} - Active private key`);
          this.pdf.text(15, 185, `${keys[1]} - Owner private key`);
          this.mnemonicsFirst.forEach((item, index) => {
            this.pdf.text(35, 195 + (index * 8), item);
          });
          this.mnemonicsSecond.forEach((item, index) => {
            this.pdf.text(125, 195 + (index * 8), item);
          });
          this.qrcodeUri = this.pdf.output('blob');
        })
      },
      downloadPdf() {

      },
      generateQR() {
        this.qrcode = new QRCode('7', 'L');
        const keys = this.privateKey.split(':');
        this.qrcode.addData(`${keys[0]}`);
        if (keys.length > 1) this.qrcode.addData(`:${keys[1]}`);
        this.qrcode.make();
        document.getElementById('qrcode').innerHTML = this.qrcode.createImgTag();
        this.createPdf();
      },
      newMnemonic() {
        this.$store.dispatch('signIn/generateMnemonic');
      },
      formatMnemonics() {
        const d = this.mnemonic;
        this.mnemonicsFirst = [];
        this.mnemonicsSecond = [];
        for (let i = 0; i <= 11; i++) {
          this.mnemonicsFirst.push(d[i] || '');
        }
        for (let i = 12; i <= 23; i++) {
          this.mnemonicsSecond.push(d[i] || '');
        }
        Wallet.getKeys().then(keys => {
          this.privateKey = keys.privateKey;
          if (d.length) {
            this.generateQR();
          }
        });
      }
    },
    watch: {
      'mnemonic': function () {
        this.formatMnemonics();
      }
    },
    mounted() {
      const md = new MobileDetect(navigator.userAgent);
      this.$refs['link'].$el.addEventListener("click", _ => {
        this.copied = true;
        if (md.is('iPhone')) {
          if (md.match('CriOS')) {
            const a = document.createElement('a');
            const blob = new Blob([this.qrcodeUri], {type: "application/pdf"});
            const url = window.URL.createObjectURL(blob);
            a.href = url;
            a.style='cursor:pointer;';
            a.download = '16Bit_qrCode.pdf';
            a.target = '_blank';
            a.rel = 'noopener';
            a.innerText = 'clickme';
            document.body.appendChild(a);
            a.click();
            a.remove();
          } else {
            const a = document.createElement('a');
            const blob = new Blob([this.qrcodeUri], {type: "octet/stream"});
            const url = window.URL.createObjectURL(blob);
            a.href = url;
            a.style='cursor:pointer;';
            a.download = '16Bit_qrCode.pdf';
            a.target = '_blank';
            a.rel = 'noopener';
            a.innerText = 'clickme';
            const dispatch = document.createEvent("HTMLEvents");
            dispatch.initEvent("click", true, true);
            a.dispatchEvent(dispatch);
          }
        } else {
          this.pdf.save('16Bit_qrCode.pdf');
        }
      }, false);
      this.formatMnemonics();
    }
  }
</script>
